/*
 * osbind.h	bindings for OS traps
 *
 */

#ifndef _OSBIND_H
#define _OSBIND_H

#ifndef _OSTRUCT_H
#include <ostruct.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* memory.c */
void *m_alloc(long);
long m_free(void *);
long m_shrink(short, void *, long);
long m_xalloc(long, short);
long p_exec(short, void *, void *, void *);
void p_term(short retcode);
void p_term0(void);

/* os.c */
unsigned short t_gettime(void);
unsigned short t_getdate(void);
long s_uper(void *stack);
long s_upexec(long (*func)(void));
long b_setexc(short, long);

/* filesys.c */
long f_create(const char *filename, short attr);
long f_delete(const char *filename);
long f_rename(short zero, const char *oldname, const char *newname);
long f_attrib(const char *filename, short wflag, short attrib);
long f_datime(_DOSTIME *timeptr, short handle, short wflag);
long f_open(const char *filename, short mode);
long f_close(short handle);
long f_read(short handle, long count, void *buf);
long f_write(short handle, long count, void *buf);
long f_seek(long offset, short handle, short seekmode);
long f_force(short stch, short nonstdh);
long d_setdrv(short drv);
long d_getdrv(void);
long d_getpath(char *path, short driveno);
long d_create(const char *path);
long d_delete(const char *path);
void f_setdta(_DTA *buf);
_DTA *f_getdta(void);
long f_sfirst(const char *filename, short attr);
long f_snext(void);

/* console.c */
long c_conws(const char *);
long c_rawcin(void);
long b_constat(short);
long b_costat(short);
long b_conin(short);
long b_conout(short, short);
long b_kbshift(short);
_IOREC *x_iorec(short);
long x_logbase(void);
long x_physbase(void);
long x_bconmap(short);
_KBDVECS *x_kbdvbase(void);
long x_keytbl(void *, void *, void *);

#ifdef __cplusplus
}
#endif

#endif /* _OSBIND_H */
